/* Copyright (C) 2006-2017 Michel Gutierrez <mig@downloadhelper.net>
 * All Rights Reserved
 * 
 * If you are interested in methods used in this project, follow the
 * open source project at https://github.com/mi-g/fang
 */



var url = window.location.href;

var imageMeta = document.querySelector("meta[property='og:image']");
var thumbnail = (imageMeta && imageMeta.getAttribute("content")) || null;

var scripts = document.querySelectorAll('script');
for(var i=0; i<scripts.length; i++) {
	var script = scripts[i];
	if(script.getAttribute("src"))
		continue;
	var nodeText = script.firstChild;
	if(!nodeText)
		continue;
	var m = /buildPlayer\((.*)\);/.exec(nodeText.nodeValue);
	if(!m)
		m = /window\.playerV5 *=.*?,(.*)\);/.exec(nodeText.nodeValue);
	if(!m)
		continue;
	try {
		var data = JSON.parse(m[1]);
		var videoMessage = {
			pageUrl: url,
			source: url,
			videoId: data.metadata.id,
			hasVideo: true,
			data: data.metadata,
			thumbnailUrl: thumbnail,
		}
		self.port.emit("detected-video",videoMessage);
		break;
	} catch($_) {};

}
